﻿Public Class Form1
    ' Redraw on resize.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.ResizeRedraw = True
    End Sub

    ' Draw rainbow colors on the form.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        Dim wid As Integer = Me.ClientSize.Width
        Dim hgt As Integer = Me.ClientSize.Height
        Dim hgt2 As Integer = Int(hgt / 2)
        For x As Integer = 0 To wid - 1
            Using the_pen As New Pen(MapRainbowColor(x, 0, wid))
                e.Graphics.DrawLine(the_pen, x, 0, x, hgt2)
            End Using
            Using the_pen As New Pen(MapRainbowColor(x, wid, 0))
                e.Graphics.DrawLine(the_pen, x, hgt2, x, hgt)
            End Using
        Next x
    End Sub

    ' Map a value to a rainbow color.
    Private Function MapRainbowColor(ByVal value As Single, ByVal red_value As Single, ByVal blue_value As Single) As Color
        ' Convert into a value between 0 and 1023.
        Dim int_value As Integer = Int(1023 * (value - red_value) / (blue_value - red_value))

        ' Map different color bands.
        If (int_value < 256) Then
            ' Red to yellow. (255, 0, 0) to (255, 255, 0).
            Return Color.FromArgb(255, int_value, 0)
        ElseIf (int_value < 512) Then
            ' Yellow to green. (255, 255, 0) to (0, 255, 0).
            int_value -= 256
            Return Color.FromArgb(255 - int_value, 255, 0)
        ElseIf (int_value < 768) Then
            ' Green to aqua. (0, 255, 0) to (0, 255, 255).
            int_value -= 512
            Return Color.FromArgb(0, 255, int_value)
        Else
            ' Aqua to blue. (0, 255, 255) to (0, 0, 255).
            int_value -= 768
            Return Color.FromArgb(0, 255 - int_value, 255)
        End If
    End Function
End Class
